#!/usr/bin/perl

# Name: ricocheting's Error-Lumberjack (logger) with administration options
# Author: ricocheting
# http://www.ricocheting.com/perl/
# Version: 2.5
# Date: 02-03-02
#
# This script is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
# 



# Error Log name (blah.txt, log.dat, etc.log)
$config{'log'}= 'log.txt'; 

# Password for administration
$config{'password'}= 'pass';

# Username for administration
$config{'username'}= 'user';

# Full location of this script (don't need to set unless bad referer error)
$config{'scriptName'}="http://$ENV{'HTTP_HOST'}$ENV{'SCRIPT_NAME'}";


# You can configure your own header which will
# be appended to the top of each page.
$config{'header'} =<<"EOF";
Content-type: text/html


<html>
<head>
<title> ricocheting's Error-Lumberjack Administration </title>
<style type="text/css"><!--
td		{font-size: 10pt; font-family: VERDANA,HELVETICA,ARIAL; padding-left:3px; padding-right:3px}
body	{font-size: 10pt; font-family: VERDANA,HELVETICA,ARIAL;}
input	{font-size: 10pt; font-family: VERDANA,HELVETICA,ARIAL;}
a:link	{text-decoration:none;}
a:visited	{text-decoration:none; color:#330066;}
a:hover	{text-decoration:underline; color:#660066;}
//-->
</style>
</head>

<body bgcolor="#ffffff"><center>
EOF


# Footer for each HTML page generated
# please leave the copyright and credits visible
$config{'footer'}=<<"EOF";
<br><br><br>
<font size=1 color=green face="VERDANA,HELVETICA,ARIAL">

ricocheting's Error-Lumberjack 2.5<br>
<i>Copyright &copy; 2000-2002 
<a href="http://www.ricocheting.com/perl/" target="_top">ricocheting</a>.</i>

</font>
</center></body></html>
EOF



# <----------- no user serviceable parts beyond this point ----------->

###############
# constructor #

local %formdata = &parse;

#display log results
if(($formdata{'action'} eq "checkPassword") && ($formdata{'username'} eq $config{'username'}) && ($formdata{'password'} eq $config{'password'})){
&display;}

#bad password
elsif($formdata{'action'} eq "checkPassword"){
&oops("Incorrect Username or Password. Please try again.<br><br>To set the password, open <b>$config{'scriptName'}</b> and follow the directions.")}

#update log
elsif($formdata{'action'} eq "setLog" && $ENV{'HTTP_REFERER'} eq $config{'scriptName'}){
&setLog;}

#bad referer for update log
elsif($formdata{'action'} eq "setLog"){
&oops("*Error writing to file. Please, only authorized users")}

#print startup screen
else{
&startup;}

#-# end constructor
###############


#-#############################################
# Sub: startup
# desc: displays the page with prompt for username/password
sub startup {

print <<"EOF";
$config{'header'}

<form method="post" action="$config{'scriptName'}">
<input type=hidden name="action" value="checkPassword">

	<table cellpadding=0 cellspacing=0><tr><td bgcolor="#333333" style="padding:0px;">
<table border=0 cellpadding=2 cellspacing=1><tr>
<td align=center bgcolor="#cccccc"><b>Username:</b></td>
<td align=center bgcolor="#cccccc"><b>Password:</b></td></tr>
<tr><td bgcolor="#eeeeee" height=35> &nbsp; 
	<input type="text" name="username"> &nbsp; </td>
<td bgcolor="#eeeeee" height=35> &nbsp; 
	<input type="password" name="password"> &nbsp; </td>
</tr><tr><td colspan=2 align=center bgcolor="#eeeeee" height=35>
	<input type="submit" value=" Sign In " style="font-weight:bold">
</td></tr></table>
	</td></tr></table>

</form>
$config{'footer'}
EOF

return;
}#-#end sub startup


#-#############################################
# Sub: display
# desc: opens the log and prints out errors

sub display {

open(FILE , $config{'log'}) or &oops("Error opening log file <b>$config{'log'}</b> -- File not found.<br>Either create file, or edit the \$config{'log'} variable in<br>$config{'scriptName'} to point to the correct file.");
my @count_visit=<FILE>;
close(FILE);
chomp(@count_visit);

print <<"EOF";
$config{'header'}

<form action="$config{'scriptName'}" method="post">
<input type=hidden name=action value=setLog>


		<table cellpadding=0 cellspacing=0><tr><td bgcolor="#333333" style="padding:0px;">
<table border=0 cellpadding=0 cellspacing=1>
<tr>
<td bgcolor="#cccccc" align=center>
<b>X</b></td>

<td bgcolor="#cccccc" align="center">
<b>\&nbsp; Type \&nbsp;</b></td>

<td bgcolor="#cccccc" align="left">
<b>Error On</b></td>

<td bgcolor="#cccccc" align="center">
<b>Time</b></td>

<td bgcolor="#cccccc" align="center">
<b>IP</b></td>

<td bgcolor="#cccccc" align="left">
<b>Error From</b></td></tr>
EOF


my $e404_count=0;
my $e403_count=0;
my $e500_count=0;
my $other_count=0;
my $total_count=0;

foreach my $temp (@count_visit){
	my @page = split(/\|\|/, $temp);

#split the logged time into something readable
my($second, $minute, $hour, $dayofmonth, $month, $year, $weekday, $dayofyear, $isdst)=localtime($page[0]);
if($hour<=12){$ampm='am'}if($hour>12){$hour=$hour-12;$ampm='pm'}
$my_time=sprintf('%d-%d-%02d &nbsp; %02d:%02d%s', $month+1,$dayofmonth,$year-100,$hour,$minute,$ampm);

#set the current color, and add the number to the total
if($page[2] eq "404"){$error_bgcolor="#FFDD88";$e404_count++;}
elsif($page[2] eq "403"){$error_bgcolor="#66CC99";$e403_count++;}
elsif($page[2] eq "500"){$error_bgcolor="#FF9999";$e500_count++;}
else{$error_bgcolor="#BBBBFF";$other_count++;}

print <<"EOF";
<tr>
<td align=center bgcolor="#eeeeee"><input type=checkbox name="id$total_count"></td>
<td align=center bgcolor="$error_bgcolor">$page[2]</td>
<td align=left bgcolor="white" nowrap>$page[3]</td>
<td align=right bgcolor="white" nowrap>$my_time</td>
<td align=center bgcolor="eeeeee">$page[1]</td>

<td align=left bgcolor="white"><a href="$page[4]" target="errorwin">$page[4]</a>\&nbsp</td>
</tr>
EOF

$total_count++;

}#end foreach @count_visit

# Print out total and average
print <<"EOF";
	<tr><td colspan=6 bgcolor="#cccccc">\&nbsp;</td></tr>

	<tr><td bgcolor="#eeeeee" colspan=3>
		<b>Total 404 errors: <font color="#999999">(not found)</font></b>
	</td><td align=right bgcolor="#eeeeee">
		<b>$e404_count</b></td>

	<td rowspan=5 colspan=2 align=center valign=center bgcolor="#eeeeee">
	<input type=button value="Check All" onClick="for(i=1;i<this.form.length-2;i++){this.form[i].checked=1;}"> 
	<input type=submit value="Delete Checked"></td></tr>

	<tr><td bgcolor="#eeeeee" colspan=3>
		<b>Total 403 errors: <font color="#999999">(restricted)</font></b>
	</td><td align=right bgcolor="#eeeeee">
		<b>$e403_count</b></td></tr>
	
	<tr><td bgcolor="#eeeeee" colspan=3>
		<b>Total 500 errors: <font color="#999999">(server error)</font></b>
	</td><td align=right bgcolor="#eeeeee">
		<b>$e500_count</b></td></tr>

	<tr><td bgcolor="#eeeeee" colspan=3>
		<b>Total other errors:</b>
	</td><td align=right bgcolor="#eeeeee">
		<b>$other_count</b></td></tr>


	<tr><td bgcolor="#cccccc" colspan=3>
		<b>Grand Total:</b>
	</td><td align=right bgcolor="#cccccc">
		<b>$total_count</b></td></tr>

	</table>
	</td></tr></table>
	</form>
	$config{'footer'}
EOF

}#-#end sub display


#-#############################################
# Sub: setLog
# updates the log to the current settings

sub setLog {

open(FILE , $config{'log'}) or  &oops("Error opening log file <b>$config{'log'}</b> -- File not found");
my @count_visit=<FILE>;
close(FILE);
chomp @count_visit;

for (my $i=$#count_visit; $i>=0; $i--) {#run it backwards so the removed items don't change position of ones that still needa be counted
	if($formdata{"id$i"}){
	#if it was checked, splice out current $i of @count_visit
	splice(@count_visit, $i, 1);
	}
}
#if line isn't mark, reprint it.  if marked with 'x' ignore
open(FILE , ">$config{'log'}") or  &oops("Error opening log file <b>$config{'log'}</b> -- File not found");
	foreach my $worker (@count_visit){
		print FILE $worker."\n";
	}#end for
close(FILE);

$config{'header'}.='<br><center><font color="green"><b>*The changes you made have been saved and the log updated.*</b></font></center><br>';

&display;
}#-#end sub setLog


#-#############################################
# Sub: parse
# desc: this takes whatever submitted and spits it out in the $formdata{''} array
# returns: associative array of parsed data.  called like: my %formdata = &parse();
sub parse {
        my @pairs;
        my @data;
		my $buffer;

    if ($ENV{'REQUEST_METHOD'} eq 'GET') {
        @pairs = split(/&/, $ENV{'QUERY_STRING'});
    }
    elsif ($ENV{'REQUEST_METHOD'} eq 'POST') {
        read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
        @pairs = split(/&/, $buffer);
    }

	foreach $pair (@pairs) {
	my($name, $value) = split(/=/, $pair);
 
	# Decode the form encoding on the name and value variables.
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		# If they try to include server side includes, erase them, so they
        # aren't a security risk if the html gets returned.  Another 
        # security hole plugged up.
        # $value =~ s/<!--(.|\n)*-->//g;

                push @data, $name;
				push @data, $value;
        }#end foreach pairs

        return @data;
}#-#end sub parse



#-#############################################
# Sub: Oops!
# decs: this generates an error message and dies
# param: (1$) specific error message for debugging
sub oops {

print <<"EOF";
$config{'header'}

	<table cellpadding=0 cellspacing=0><tr><td bgcolor="#333333" style="padding:0px;">
<table border=0 cellpadding=2 cellspacing=1><tr>
<td align=center bgcolor="#cccccc"><b>ERROR</b></td></tr>

<tr><td bgcolor="#eeeeee">
<br>$_[0]
<br><br>
<hr size=1 noshade width="80%" color="#333333">
<center>Please hit the <a href="javaScript:history.back();"><b>back button</b></a> on your browser to try again.</center>

</td></tr></table>
	</td></tr></table>

$config{'footer'}
EOF

die "Error: $_[0]\n";
}#-#end sub oops
